##
##  typescript.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2024 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg             5.5.4
%define       V_typescript       5.5.4
%define       V_typescript_snap  20240723

#   package information
Name:         typescript
Summary:      TypeScript Language Compiler
URL:          http://www.typescriptlang.org/
Vendor:       Microsoft
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      Apache
Version:      %{V_opkg}
Release:      20240723

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/typescript/typescript-%{V_typescript}-%{V_typescript_snap}.tar.gz
Source1:      tsc.sh
Source2:      ts.sh

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, node-openpkg
PreReq:       OpenPKG, openpkg >= 20160101, node

%description
    TypeScript is a type-safe superset of JavaScript that compiles down
    to plain JavaScript.

%track
    prog typescript = {
        version   = %{V_typescript}
        url       = https://github.com/Microsoft/TypeScript/releases
        regex     = tree/v(\d+\.\d+(?:\.\d+)?)
    }
    prog typescript:snapshot = {
        version   = %{V_typescript_snap}
        url       = http://download.openpkg.org/components/versioned/typescript/
        regex     = typescript-__VER__-(\d+)\.tar\.gz
    }

%prep
    %setup -q -c

%build
    %{l_prefix}/bin/node-openpkg squeeze -n "default:safe"

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/lib/typescript
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE tsc.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/tsc
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE ts.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/ts
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE ts.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/ts-node
    %{l_prefix}/bin/node-openpkg install \
        %{l_prefix}/lib/typescript/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

